#include <algorithm>
#include <cctype>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <utility>

using namespace std;

#define DEBUG(x) cout << ">>> " << #x << " : " << x << endl;
#define REP(i,a) for (int i = 0; i < (a); ++i)
#define FOR(i,a,b) for (int i = (a); i <= (b); ++i)
#define FORD(i,a,b) for (int i = (a); i >= (b); --i)
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }
const int INF = 1<<29;

typedef long long ll;


#define M 1000000

char s[1005];
int n;
int f[1005][1005];

int main() {
	while(scanf("%s",s) == 1){
		n = strlen(s);
		f[0][0]=1;
		FOR(i,1,n){
			REP(j,(i+1)){
				f[i][j]=0;
				if(2*j<i) continue;
				if((s[i-1]=='.' || s[i-1]=='(') && j>0) f[i][j]=f[i-1][j-1];
				if((s[i-1]=='.' || s[i-1]==')') && j<n) f[i][j]=(f[i][j]+f[i-1][j])%M;
				//DEBUG(i); DEBUG(j); DEBUG(f[i][j]);
			}
		}
		printf("%d\n",f[n][n/2]);

	}
	return 0;
}
