#include <algorithm>
#include <cctype>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <utility>

using namespace std;

#define DEBUG(x) cout << ">>> " << #x << " : " << x << endl;
#define REP(i,a) for (int i = 0; i < (a); ++i)
#define FOR(i,a,b) for (int i = (a); i <= (b); ++i)
#define FORD(i,a,b) for (int i = (a); i >= (b); --i)
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }
const int INF = 1<<29;

typedef long long ll;

int main() {
		
	while(scanf("%c%c%c%c%c%c",&c1,&c2,&c5,&c3,&c4,&c6) == 6){
		//DEBUG(c1);
		d1 = charnum(c1);
		d2 = charnum(c2);
		d3 = charnum(c3);
		d4 = charnum(c4);
		//DEBUG(d1);
		//DEBUG(d2);
		//DEBUG(d3);
		//DEBUG(d4);
		if(!done[d1][d2]){
			Xzero = zero;
			REP(k,8){
				REP(i,5) REP(j,5) Xzero.arr[i+5][j+5] = tiles[d1][k].arr[i][j];
				REP(m,10) REP(n,10){
					ok=true;
					X = Xzero;
					REP(i,5) REP(j,5){
						if(X.arr[i+m][j+n]=='x' && tiles[d2][0].arr[i][j]=='x') ok=false;
						if(tiles[d2][0].arr[i][j]=='x') X.arr[i+m][j+n]=tiles[d2][0].arr[i][j];
					}
					con = X;
					if(ok && is_connected()){
						pos[d1][d2].push_back(X);
					}
				}
			}

		}
		if(!done[d3][d4]){
			d1 = d3; d2 = d4;
			Xzero = zero;
			REP(k,8){
				REP(i,5) REP(j,5) Xzero.arr[i+5][j+5] = tiles[d1][k].arr[i][j];
				REP(m,10) REP(n,10){
					ok=true;
					X = Xzero;
					REP(i,5) REP(j,5){
						if(X.arr[i+m][j+n]=='x' && tiles[d2][0].arr[i][j]=='x') ok=false;
						if(tiles[d2][0].arr[i][j]=='x') X.arr[i+m][j+n]=tiles[d2][0].arr[i][j];
					}
					con = X;
					if(ok && is_connected()){
						pos[d1][d2].push_back(X);
					}
				}
			}
		}
		d1 = charnum(c1); d2 = charnum(c2);

		ok=false;
		REP(i,pos[d1][d2].size()){
			if(ok) break;
			REP(j,pos[d3][d4].size()){
				if(ok) break;
				if(compare(pos[d1][d2][i],pos[d3][d4][j])) ok=true;
			}
		}
		if(ok) printf("YES\n");
		else printf("NO\n");
	}
	return 0;
}
